apiVersion: camel.apache.org/v1alpha1
kind: Kamelet
metadata:
  name: chuck-norris-source
  annotations:
    camel.apache.org/kamelet.support.level: "Preview"
    camel.apache.org/catalog.version: "main-SNAPSHOT"
    camel.apache.org/kamelet.icon: data:image/svg+xml;base64,[encoded data, 8704 characters]
    camel.apache.org/provider: "Apache Software Foundation"
    camel.apache.org/kamelet.group: "Chuck Norris"
  labels:
    camel.apache.org/kamelet.type: "source"
spec:
  definition:
    title: "Chuck Norris Source"
    description: |-
      Gets periodically Chuck Norris jokes from https://api.chucknorris.io/
    type: object
    properties:
      period:
        title: Period
        description: The interval (msec) to wait before getting the next joke
        type: integer
        default: 10000
  types:
    out:
      mediaType: text/plain
  dependencies:
    - "camel:kamelet"
    - "camel:timer"
    - "camel:http"
    - "camel:jsonpath"
  template:
    from:
      uri: "timer:chuck"
      parameters:
        period: "{{period}}"
      steps:
        - to: "https://api.chucknorris.io/jokes/random?category=dev"
        - set-body:
            jsonpath: "$.value"
        - to: "kamelet:sink"
